/****************************************************************************/
/*  Copyright 2005, Trustees of Indiana University                          */
/*  Author: Sidharth Thakur                                                 */
/*  Last modified: 14 January 2006                                          */
/*  License available at: <belt-trick-* folder>/docs/downloads/License.txt  */
/****************************************************************************/
#ifndef _OGLWIDGETMAIN_
#define _OGLWIDGETMAIN_

#include <qgl.h>
#include "all.h"

class OGLWidgetMain : public QGLWidget 
{
public:
	OGLWidgetMain( QWidget* parent, const char* name, QWidget* parentForm );
	~OGLWidgetMain ( );

public: //VARIABLES
	// world center
	GLfloat			XC, YC, ZC;					//
    int				X,	Y,	dX, dY;				//
    GLfloat			Cx, Cy, Cz;					//
    double			m_viewScale;				//
    int				main_height, main_width;	//
    int     		enable_picking;				//
    float			xCoord[MAX_POINTS];			//
    float			yCoord[MAX_POINTS];			//
    float			zCoord[MAX_POINTS];			//

	// lighting
    GLfloat 		global_light0[4];			//
	
	QString			helpstr;

	// View-port parameters
    float			xMin;						//
    float			xMax;						//
    float			yMin;						//
    float			yMax;						//
    float			zNear;						//
    float			zFar;						//

	// mouse event data handlers
    float			startY;						//
    int				xBegin, xNext;				//
    int				yBegin, yNext;				//
	int				modkey;						//
    int				button;						//
    int				mouseModifiers;				//
	int				mouseButtons;				//

	// mouse: picking data handlers
	int				litVertex;					//
    int				movingPoint;				//

    int dumpscreen;
    

public: //FUNCTIONS
	/* ADMINISTRATION */
	//window operations
	void			initializeGL		( void );						//
	void			init				( void );						//
	void			initLighting		( void );						//
	void			setupLights			( void );						//
	void			paintGL				( void );						//
	void			resizeGL			( int wd, int ht ); 			//
	void			resetApp			( void );						//
	void			showOnScreenText	( void );						//
	void			text				( char* string );				//
	int				DumpScreen			( int width,int height );		//
    int             saveToBMP           ( int width, int height );



	//event handlers
    void			keyPressEvent				( QKeyEvent *e );		//			
	void			mousePressEvent				( QMouseEvent *e );		//
	void			mouseReleaseEvent			( QMouseEvent *e );		//
	void			moveTransformedCoordinate	( float x, float y );	//
	void			mouseMoveEvent				( QMouseEvent *e );		//


        
};


#endif

